#include "ColoredSwitchButtonCell.h"
#include "Macros.h"

@implementation ColoredSwitchButtonCell
- (id)init
{
    self = [super init];
    [self setButtonType:NSSwitchButton];
    return self;
}

- (void) dealloc
{
    Assign(color, nil);
    [super dealloc];
}

- (void)setColor:(NSColor *)c
{
    Assign(color, c);
}

- (void)drawInteriorWithFrame:(NSRect)frame
                       inView:(NSView *)controlView
{
    NSRect r = frame;
    
    r.size.width = r.size.height;
    r = NSInsetRect(r, 3, 3);
    [color set];
    NSRectFill(r);
    
    r = NSOffsetRect(frame, NSHeight(frame), 0);
    r.size.width -= NSHeight(frame);
    [super drawInteriorWithFrame:r inView:controlView];
}
@end
