#ifndef _EntityDescriptor_h_
#define _EntityDescriptor_h_

// EntityDescriptor
//
// holds a small description of an entityType
//

#include <Foundation/Foundation.h>

#include "Protocols.h"
#include "Macros.h"


@interface EntityDescriptor : NSObject
{
    NSString *entityType;
    PajeDrawingType drawingType;
}

//
// Initialisation
//
+ (EntityDescriptor *)descriptorWithEntityType:(NSString *)type
                                   drawingType:(PajeDrawingType)drawType;
- (id)initWithEntityType:(NSString *)type
             drawingType:(PajeDrawingType)drawType;
- (void)dealloc;

//
// Accessors
//
- (NSString *)entityType;
- (PajeDrawingType)drawingType;

- (NSArray *)allNames;
@end

#endif