#include "EntityDescriptor.h"

@implementation EntityDescriptor : NSObject

//
// Initialisation
//

+ (EntityDescriptor *)descriptorWithEntityType:(NSString *)type
                                   drawingType:(PajeDrawingType)drawType
{
    return [[[self alloc] initWithEntityType:type
                                 drawingType:drawType] autorelease];
}

- (id)initWithEntityType:(NSString *)type
             drawingType:(PajeDrawingType)drawType
{
    self = [super init];
    if (self) {
        Assign(entityType, type);
        drawingType = drawType;
    }
    return self;
}

- (void)dealloc
{
    Assign(entityType, nil);
    [super dealloc];
}


//
// Accessors
//

- (NSString *)entityType { return entityType; }
- (PajeDrawingType)drawingType { return drawingType; }

- (NSArray *)allNames
{
    return nil;
}
@end
