/* FilteredEnumerator.m created by benhur on Sat 14-Jun-1997 */

#include "FilteredEnumerator.h"

@implementation FilteredEnumerator

+ (FilteredEnumerator *)enumeratorWithEnumerator:(NSEnumerator *)orgEnum
                                          filter:(NSSet *)names
{
    return [[[self alloc] initWithEnumerator:orgEnum
                                      filter:names] autorelease];
}

+ (FilteredEnumerator *)enumeratorWithEnumerator:(NSEnumerator *)orgEnum
                                          filter:(NSSet *)names
                                        selector:(SEL)sel
{
    return [[[self alloc] initWithEnumerator:orgEnum
                                      filter:names
                                    selector:sel] autorelease];
}

- (id)initWithEnumerator:(NSEnumerator *)orgEnum
                  filter:(NSSet *)names
{
    return [self initWithEnumerator:orgEnum
                             filter:names
                           selector:NULL];
}

- (id)initWithEnumerator:(NSEnumerator *)orgEnum
                  filter:(NSSet *)names
                selector:(SEL)sel
{
    self = [super init];
    if (self) {
        originalEnumerator = [orgEnum retain];
        filter = [names retain];
        selector = sel;
    }
    return self;
}

- (void)dealloc
{
    [originalEnumerator release];
    [filter release];
    [super dealloc];
}

- (id)nextObject
{
    id obj;
    if (selector)
        while ((obj = [originalEnumerator nextObject])
               && (nil != [filter member:[obj performSelector:selector]]))
            ;
    else
        while ((obj = [originalEnumerator nextObject])
               && (nil != [filter member:obj]))
            ;
    return obj;
}
@end
