/*
 * GNUstep+Additions
 *
 * Some missing methods in GNUstep
 */

#ifdef GNUSTEP

#include <AppKit/AppKit.h>

@implementation NSAttributedString (Additions)
- (NSComparisonResult)compare:(id)other
{
    if ([other isKindOfClass:[NSAttributedString class]]) {
        return [[self string] compare:[(NSAttributedString *)other string]];
    } else if ([other isKindOfClass:[NSString class]]) {
        return [[self string] compare:(NSString *)other];
    }
    return [super compare:other];
}
@end

@implementation NSClipView (Additions)
- (void) viewFrameChanged: (NSNotification*)aNotification
{
  NSRect proposedVisibleRect;
  NSRect newVisibleRect;
  NSRect newBounds;

  // give documentView a chance to adjust its visible rectangle
  proposedVisibleRect = [self convertRect: _bounds toView: _documentView];
  newVisibleRect = [_documentView adjustScroll: proposedVisibleRect];
  newBounds = [self convertRect: newVisibleRect fromView: _documentView];
  newBounds.origin = [self constrainScrollPoint: newBounds.origin];
  [self setBounds: newBounds];

  /* If document frame does not completely cover _bounds */
  if (NSContainsRect([_documentView frame], _bounds) == NO)
    {
      /*
       * fill the area not covered by documentView with background color
       */
      [self setNeedsDisplay: YES];
    }

  [_super_view reflectScrolledClipView: self];
}

@end
#endif
