//
// PajeContainer
//
// superclass for containers
//

#include "PajeContainer.h"
#include "Macros.h"
#include "UniqueString.h"
#include "PTime.h"

@implementation PajeContainer

+ (PajeContainer *)containerWithType:(id)type
                                name:(NSString *)n
                           container:(PajeContainer *)c
{
    return [[[self alloc] initWithType:type
                                  name:n
                             container:c] autorelease];
}

- (id)initWithType:(PajeEntityType *)type
              name:(id)n
         container:(PajeContainer *)c
{
    self = [super initWithType:type
                          name:n
                     container:c];
    if (self) {
        Assign(subContainers, [NSMutableArray array]);
    }
    return self;
}

- (void)dealloc
{
    Assign(subContainers, nil);
    [super dealloc];
}

- (void)addSubContainer:(PajeContainer *)subcontainer
{
    [subContainers addObject:subcontainer];
}

- (NSArray *)subContainers
{
    return subContainers;
}
 
- (BOOL)isContainer
{
    return YES;
}

- (NSDate *)time
{
    return [NSDate/*PTime*/ dateWithTimeIntervalSinceReferenceDate:0.0];
}

- (NSDate *)endTime
{
    return [NSDate/*PTime*/ dateWithTimeIntervalSinceReferenceDate:200.0];
}

- (id)copyWithZone:(NSZone *)zone
{
    return [self retain];
}

- (NSString *)alias
{
    return nil;
}

- (PajeContainerType *)entityType
{
    return (PajeContainerType *)[super entityType];
}

// NSCoding protocol
- (void)encodeWithCoder:(NSCoder *)coder
{
    [super encodeWithCoder:coder];
    [coder encodeObject:subContainers];
}

- (id)initWithCoder:(NSCoder *)coder
{
    self = [super initWithCoder:coder];
    Assign(subContainers, [coder decodeObject]);
    return self;
}
@end
