#ifndef _PajeController_h_
#define _PajeController_h_

#include <AppKit/AppKit.h>
#include "PajeTraceController.h"

@interface PajeController:NSObject
{
    NSMutableArray *traceControllers;
    PajeTraceController *currentTraceController;
    
    IBOutlet NSWindow *filtersWindow;
    IBOutlet NSPopUpButton *filtersPopUp;
    IBOutlet NSBox *filtersDummyView;
    IBOutlet NSMenu *filtersMenu;
    IBOutlet NSMenu *toolsMenu;
}

+ (PajeController *)controller;
- (void)filterChanged:(id)sender;
- (void)filterMenuSelected:(id)sender;

- (void)print:(id)sender;
- (void)open:(id)sender;

- (void)setCurrentTraceController:(PajeTraceController *)controller;
- (void)updateToolsMenu;
- (void)updateFiltersMenu;

// NSApplication delegate
- (BOOL)application:(NSApplication *)sender openFile:(NSString *)filename;

@end

@interface NSObject (PajeFilterDelegate)
- (void)viewWillBeSelected:(NSView *)view;
@end

#endif
