#ifndef _PajeEventDecoder_h_
#define _PajeEventDecoder_h_

#include <Foundation/Foundation.h>
#include "../General.bproj/PajeEvent.h"
#include "../General.bproj/PTime.h"
#include "../General.bproj/DataScanner.h"
#include "../General.bproj/PajeFilter.h"

@interface PajeEventDecoder: PajeComponent
{
    enum { OUT_DEF, IN_DEF, EVENTS } status;
    
    struct {
        NSMutableArray *fieldTypes;
        NSMutableArray *fieldNames;
        NSNumber *eventId;
        NSString *eventName;
    } eventBeingDefined;
    NSMutableArray *valArray; /* used only while reading an event */
    
    int eventCount;
    int lineCount;

    NSMutableDictionary *eventNames;
    NSMutableDictionary *eventFieldTypes;
    NSMutableDictionary *eventFieldNames;

    DataScanner *scanner;
    NSCharacterSet *percent;
    NSCharacterSet *delimiter;
    NSMutableCharacterSet *alphanum;
}

- (id)initWithController:(PajeTraceController *)c;
- (BOOL)readNextLine;
- (void)scanDefinitionLine;
- (PajeEvent *)readEvent;
- (void)reset;
- (void)raise:(NSString *)reason;

- (int)eventCount;

- (void)encodeCheckPointWithCoder:(NSCoder *)coder;
- (void)decodeCheckPointWithCoder:(NSCoder *)coder;
@end
#endif
