// EventNames.h
//
// declaration of event names.
// include this file with the following symbol #defined:
//     nothing - declaration of variables as extern
//     DEFINE_STRINGS - declaration of variables not extern
//     INIT_STRINGS - initialization of variables


#if defined(INIT_STRINGS)
#  define CONSTANT_STRING(str, init) str##EventName = [UniqueString stringWithString:init]
#else
#  if defined(DEFINE_STRINGS)
#    define CONSTANT_STRING(str, init) NSString *str##EventName
#  else // declare strings
#    define CONSTANT_STRING(str, init) extern NSString *str##EventName
#  endif
#endif

CONSTANT_STRING(PajeStartTrace,             @"PajeStartTrace");
CONSTANT_STRING(PajeDefineContainerType,    @"PajeDefineContainerType");
CONSTANT_STRING(PajeDefineEventType,        @"PajeDefineEventType");
CONSTANT_STRING(PajeDefineStateType,        @"PajeDefineStateType");
CONSTANT_STRING(PajeDefineVariableType,     @"PajeDefineVariableType");
CONSTANT_STRING(PajeDefineLinkType,         @"PajeDefineLinkType");
CONSTANT_STRING(PajeDefineEntityValue,      @"PajeDefineEntityValue");
CONSTANT_STRING(PajeCreateContainer,        @"PajeCreateContainer");
CONSTANT_STRING(PajeDestroyContainer,       @"PajeDestroyContainer");
CONSTANT_STRING(PajeNewEvent,               @"PajeNewEvent");
CONSTANT_STRING(PajeSetState,               @"PajeSetState");
CONSTANT_STRING(PajePushState,              @"PajePushState");
CONSTANT_STRING(PajePopState,               @"PajePopState");
CONSTANT_STRING(PajeSetVariable,            @"PajeSetVariable");
CONSTANT_STRING(PajeAddVariable,            @"PajeAddVariable");
CONSTANT_STRING(PajeSubVariable,            @"PajeSubVariable");
CONSTANT_STRING(PajeStartLink,              @"PajeStartLink");
CONSTANT_STRING(PajeEndLink,                @"PajeEndLink");
#undef CONSTANT_STRING
