#ifndef _UserState_h_
#define _UserState_h_
//
// UserState
//
// holds a user-definable state
//

#include "UserEvent.h"

@interface UserState : UserEvent
{
    PajeEvent *endEvent;
    int imbricationLevel;
}

+ (UserState *)stateOfType:(PajeEntityType *)type
                     value:(id)v
                 container:(PajeContainer *)c
                startEvent:(PajeEvent *)e;
- (id)initWithType:(PajeEntityType *)type
             value:(id)v
         container:(PajeContainer *)c
        startEvent:(PajeEvent *)e;
- (void)dealloc;

- (void)setEndEvent:(PajeEvent *)event;

- (id)value;

- (NSDate *)endTime;

- (void)setImbricationLevel:(int)level;
- (int)imbricationLevel;
@end

@interface UserStateInspector : UserEventInspector
@end

#endif
